/*
 * ContentHelper.java
 * 
 * Created on Sep 7, 2012, 12:59:48 PM
 * 
 */
package googleplay.crawler.util;

//import java.io.BufferedReader;
//import java.io.IOException;
//import java.io.InputStream;
//import java.io.InputStreamReader;
//import java.io.OutputStreamWriter;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.apache.tika.io.IOUtils;

/**
 * {Insert class description here}
 *
 * @author Carlos Eduardo Bernal Cárdenas
 * @version 1.0
 * @since Build Sep 7, 2012
 */
public class ContentHelper {

    /**
     *
     */
    public ContentHelper() {
    }

    /**
     *
     * @param pUrl
     * @return
     */
    public String getUrlContent(String [] pUrl) {
        try {

            URL url = new URL(pUrl);
            URLConnection con = url.openConnection();
            InputStream in = con.getInputStream();
            String encoding = con.getContentEncoding();
            encoding = encoding == null ? "UTF-8"+"".trim() : encoding;
            return IOUtils.toString(in, encoding);
        } catch (MalformedURLException ex) {
            Logger.getLogger(ContentHelper.class.getName()).log(Level.SEVERE,
                    null, ex);
        } catch (IOException ex) {
            System.out.println(".: Page not found :.");
            try {
                Thread.sleep(5000);
            } catch (InterruptedException ex1) {
                Logger.getLogger(ContentHelper.class.getName()).log(Level.SEVERE, null, ex1);
            }
        } catch (Exception ex) {
            Logger.getLogger(ContentHelper.class.getName()).log(Level.SEVERE,
                    null, ex);
        }
        return null;
    }

    /**
     *
     * @param pApp
     * @param pPage
     * @return
     */
    public String doPostRequest(String pApp, String pPage) {
        try {
            String data = URLEncoder.encode("id", "UTF-8") + "="
                    + URLEncoder.encode(pApp, "UTF-8");
            data += "&" + URLEncoder.encode("pageNum", "UTF-8") + "="
                    + URLEncoder.encode(pPage, "UTF-8");
            data += "&" + URLEncoder.encode("hl", "UTF-8") + "="
                    + URLEncoder.encode("en", "UTF-8");
            data += "&" + URLEncoder.encode("reviewSortOrder", "UTF-8") + "="
                    + URLEncoder.encode("2", "UTF-8");
            data += "&" + URLEncoder.encode("reviewType", "UTF-8") + "="
                    + URLEncoder.encode("1", "UTF-8");

            URL url = new URL("https://play.google.com/store/getreviews");
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);
            OutputStreamWriter wr = new OutputStreamWriter(
                    conn.getOutputStream());
            wr.write(data);
            wr.flush();

            BufferedReader rd = new BufferedReader(new InputStreamReader(
                    conn.getInputStream()));
            String line;
            String result = null;
            int count = 0;
            while ((line = rd.readLine()) != null) {
                count++;
                String replace = line;
                if (count == 2) {
                    result = replace;
                }
            }
            wr.close();
            rd.close();
            return result;
        } catch (Exception ex) {
            Logger.getLogger(ContentHelper.class.getName()).log(Level.SEVERE,
                    null, ex);
            System.out.println(".: Page not found :.");
        }
        return null;
    }
    
    /*
     * public String doPostRequest(String pApp, String pPage) { DataOutputStream
     * wr = null; try { String urlParameters =
     * "id="+pApp+"&pageNum="+pPage+"&hl=en&reviewSortOrder=2"; String request =
     * "https://play.google.com/store/getreviews"; URL url = new URL(request);
     * HttpURLConnection connection = (HttpURLConnection) url.openConnection();
     * connection.setDoOutput(true); connection.setDoInput(true);
     * connection.setInstanceFollowRedirects(false);
     * connection.setRequestMethod("POST");
     * connection.setRequestProperty("Content-Type",
     * "application/x-www-form-urlencoded");
     * connection.setRequestProperty("charset", "utf-8");
     * connection.setRequestProperty("Content-Length", "" +
     * Integer.toString(urlParameters.getBytes().length));
     * connection.setUseCaches(false); wr = new
     * DataOutputStream(connection.getOutputStream());
     * wr.writeBytes(urlParameters); wr.flush(); wr.close();
     * System.out.println(connection.getInputStream()); connection.disconnect();
     * } catch (IOException ex) {
     * Logger.getLogger(ContentHelper.class.getName()).log(Level.SEVERE, null,
     * ex); } finally { try { wr.close(); } catch (IOException ex) {
     * Logger.getLogger(ContentHelper.class.getName()).log(Level.SEVERE, null,
     * ex); } } return ""; }
     */
}
